AC_DEFUN(AC_YYY_CC_CXX_BEGIN, [

AC_ARG_ENABLE(debug,
[  --enable-debug          do not strip binaries but add debug info],
yyydebug=yes, yyydebug=no)

AC_ARG_ENABLE(profiling,
[  --enable-profiling      every program creates profiling output],
yyyprofiling=yes, yyyprofiling=no)

AC_ARG_ENABLE(nooptimizing,
[  --enable-nooptimizing   do not optimize],
yyynooptimizing=yes, yyynooptimizing=no)

AC_ARG_ENABLE(nowarnerror,
[  --enable-nowarnerror    do not stop make if compiler warning],
yyynowarnerror=yes, yyynowarnerror=no)


AC_ARG_WITH(cccxxpre,
[  --with-cccxxpre=x       add at beginning of C and C++ options],
yyycccxxpre="$withval",yyycccxxpre="")

AC_ARG_WITH(cccxxpost,
[  --with-cccxxpost=x      add at end of C and C++ options],
yyycccxxpost="$withval",yyycccxxpost="")


AC_ARG_WITH(ldpre,
[  --with-ldpre=x          add at beginning of linker options],
yyyldpre="$withval",yyyldpre="")

AC_ARG_WITH(ldpost,
[  --with-ldpost=x         add at end of linker options],
yyyldpost="$withval",yyyldpost="")


YYY_CFLAGS=""
YYY_CXXFLAGS=""
YYY_LDFLAGS=""

])


AC_DEFUN(AC_YYY_CC_INIT, [

AC_ARG_WITH(ccpre,
[  --with-ccpre=x          add at beginning of C options],
yyyccpre="$withval",yyyccpre="")

AC_ARG_WITH(ccpost,
[  --with-ccpost=x         add at end of C options],
yyyccpost="$withval",yyyccpost="")

# if not set then set it as empty, so that AC_PROG_CC doesn't set it
if test "$CFLAGS" = ""; then
  CFLAGS=""
fi
AC_PROG_CC

YYY_CFLAGS="$CFLAGS"

if test "$yyynooptimizing" = "yes"; then
  YYY_CFLAGS="$YYY_CFLAGS -O0"
else
  YYY_CFLAGS="$YYY_CFLAGS -O2"
fi

if test "$yyyprofiling" = "yes"; then
  yyydebug=yes
  YYY_CFLAGS="$YYY_CFLAGS -pg"
  YYY_LDFLAGS="$YYY_LDFLAGS -pg"
fi

if test "$yyydebug" = "yes"; then
  YYY_CFLAGS="$YYY_CFLAGS -g"
else
  YYY_LDFLAGS="$YYY_LDFLAGS -s"
fi

if test "$yyynowarnerror" = "yes"; then
  YYY_CFLAGS="$YYY_CFLAGS -Wall"
else
  YYY_CFLAGS="$YYY_CFLAGS -Wall -Werror"
fi

])


AC_DEFUN(AC_YYY_CXX_INIT, [

AC_ARG_WITH(cxxpre,
[  --with-cxxpre=x         add at beginning of C++ options],
yyycxxpre="$withval",yyycxxpre="")

AC_ARG_WITH(cxxpost,
[  --with-cxxpost=x        add at end of C++ options],
yyycxxpost="$withval",yyycxxpost="")

# if not set then set it as empty, so that AC_PROG_CXX doesn't set it
if test "$CXXFLAGS" = ""; then
  CXXFLAGS=""
fi
AC_PROG_CXX

YYY_CXXFLAGS="$CXXFLAGS"

if test "$yyynooptimizing" = "yes"; then
  YYY_CXXFLAGS="$YYY_CXXFLAGS -O0"
else
  YYY_CXXFLAGS="$YYY_CXXFLAGS -O2"
fi

if test "$yyyprofiling" = "yes"; then
  yyydebug=yes
  YYY_CXXFLAGS="$YYY_CXXFLAGS -pg"
  LDFLAGS="$LDFLAGS -pg"
fi

if test "$yyydebug" = "yes"; then
  YYY_CXXFLAGS="$YYY_CXXFLAGS -g"
else
  YYY_LDFLAGS="$YYY_LDFLAGS -s"
fi

if test "$yyynowarnerror" = "yes"; then
  YYY_CXXFLAGS="$YYY_CXXFLAGS -Wall"
else
  YYY_CXXFLAGS="$YYY_CXXFLAGS -Wall -Werror"
fi

])


AC_DEFUN(AC_YYY_CC_CXX_END, [

CFLAGS="$yyyccpre $yyycccxxpre $YYY_CFLAGS $yyycccxxpost $yyyccpost"
CXXFLAGS="$yyycxxpre $yyycccxxpre $YYY_CXXFLAGS $yyycccxxpost $yyycxxpost"
LDFLAGS="$yyyldpre $YYY_LDFLAGS $yyyldpost"

])
