/*
  
  This file is part of ERIKYYYPHONE
  Copyright (C) 1996 Erik Thiele
  see README for details and contact adresses.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  */

#ifndef __CCOMMON_H
#define __CCOMMON_H

#include "allgtypedef.H"
#include "msgarten.H"
#include "serverconnection.H"
#include "outconnection.H"

void Ccommon_output(uint8 msgart,char *message,uint16 len);
void Ccommon_input(uint8 msgart,char *message,uint16 len);

void Ccommon_init();
void Ccommon_deinit();

void Ccommon_serverconnect_addnew(serverconnection_statustype *st);
void Ccommon_serverconnect_del(int32 ip);
void Ccommon_serverconnect_modify(serverconnection_statustype *st);

void Ccommon_outconnect_addnew(outconnection_statustype *st);
void Ccommon_outconnect_del(int32 ip);
void Ccommon_outconnect_modify(outconnection_statustype *st);

void Ccommon_logmsg(char *msg);

void Ccommon_recordwishstat(int anaus);
void Ccommon_recordstat(int anaus);

extern int Ccommon_ready;

#endif
