/*
  
  This file is part of ERIKYYYPHONE
  Copyright (C) 1996 Erik Thiele
  see README for details and contact adresses.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  */

#include "buffer.H"

#include "fatal.H"
#include <string.h>
#include <stdlib.h>

void buffer::vornekill(int many)
{
  if (many<0) fatalfehler("buffer::vornekill: many<0");
  if (many>bufsize) fatalfehler ("buffer::vornekill: many>bufsize");
  memmove(data,data+many,bufsize-many);
  bufsize-=many;
  if (bufsize) {
    data=(char*)realloc(data,bufsize);
  }else{
    data=(char*)realloc(data,1);  
  };
};

buffer::buffer()
{
  bufsize=0;
  data=(char*)malloc(1);
};

buffer::~buffer()
{
  free(data);
};

void buffer::changesize(int _bufsize)
{
  if (_bufsize<0) fatalfehler("buffer::changesize: _bufsize<0");
  bufsize=_bufsize;
  if (bufsize) {
    data=(char*)realloc(data,bufsize);
  }else{
    data=(char*)realloc(data,1);  
  };
};
