/*
  
  This file is part of ERIKYYYPHONE
  Copyright (C) 1996 Erik Thiele
  see README for details and contact adresses.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  */

#include "fatal.H"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <syslog.h>
#include <signal.h>
#include <errno.h>

void fatalfehler(const char *const s)
{
  char msg[10000]="\n\n*** Fatal error, program terminated, core dumped ***\n\n";
  char msg2[10000];
  sprintf(msg2,"%s\n\n",s);
  strcat(msg,msg2);

  if (FATAL_tosyslog) {
    syslog(LOG_ERR,msg);
  }else{
    fprintf(stderr,msg);
  };

  raise(SIGSEGV);
};

void fatalfehlererrno(const char *const s)
{
  char msg[10000]="\n\n*** Fatal error, program terminated, core dumped ***\n\n";
  char msg2[10000];
  sprintf(msg2,"%s\n",s);
  strcat(msg,msg2);
  sprintf(msg2,"errno: %s\n\n",strerror(errno));
  strcat(msg,msg2);

  if (FATAL_tosyslog) {
    syslog(LOG_ERR,msg);
  }else{
    fprintf(stderr,msg);
  };

  raise(SIGSEGV);
};

int FATAL_tosyslog=0;
