/*
  
  This file is part of ERIKYYYPHONE
  Copyright (C) 1996 Erik Thiele
  see README for details and contact adresses.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  */

#ifndef __OUTCONNECTION_H
#define __OUTCONNECTION_H

#include "buffer.H"
#include "MSG.H"
#include "erikyyylist.H"

typedef struct {
  enum {CONNECTING=4,ON_AIR=0,IDLE=1,BUFFER=2,WANT_TO_PLAY=3}; //gleich wie bei serverconnection.H!
  int32 ip;
  char status; // nur ein char ! wegen byte order problem. (dies hier ist eigentlich ein statustype)
  // spaeter achtung big/little endian problem bei typconvertierung ueber pointer...
  int16 buffill;
} outconnection_statustype;

class outconnection {
public:
  outconnection(int32 _ip);
  ~outconnection();

  void sendeforcemsg();
  void sendeblock(buffer *buf);

  void notifynewclient(MSG_communicator *x);
  int handleevent();

  outconnection_statustype st;

private:
  MSG_communicator *com;
  MSG_client *cl;
  int commmodus;
};

extern liste<outconnection> *outconnectionlist;

#endif
