/*
  
  This file is part of ERIKYYYPHONE
  Copyright (C) 1996 Erik Thiele
  see README for details and contact adresses.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  */

#include "recorder.H"

#include "buffer.H"
#include "sound.H"
#include "fatal.H"
#include "outconnection.H"
#include "clientconnection.H"
#include "msgarten.H"
#include <string.h>


int8 RECORDER_moechterecord;
int8 RECORDER_ichrecorde;
static buffer *recordbuffer;
static buffer *compressbuffer;


void RECORDER_init()
{
  RECORDER_ichrecorde=0;
  RECORDER_moechterecord=0;
  recordbuffer=new buffer();
  compressbuffer=new buffer();
  compressbuffer->changesize(ANZ_BYTES_PRO_COMPRESSEDGSM);
};


void RECORDER_deinit()
{
  delete compressbuffer;
  delete recordbuffer;
  if (RECORDER_ichrecorde) {
    SOUND_setrecordingmode(0);
    SOUND_setrecordlock(0);
  };
};

void RECORDER_handleevent()
{
  if (RECORDER_moechterecord&&(!RECORDER_ichrecorde)) {
    if (SOUND_setrecordlock(1)) {
      SOUND_setrecordingmode(1);
      RECORDER_ichrecorde=1;
      clientconnection::sendmsg(MSG_STATUS_OF_RECORD,
				&RECORDER_ichrecorde,sizeof(RECORDER_ichrecorde));
    };
  };
  
  if (RECORDER_ichrecorde) {
    if (SOUND_recordable()) {
      SOUND_recordblock(recordbuffer);
      
      if (!RECORDER_moechterecord) {
	if ((recordbuffer->bufsize)%(ANZ_SAMPLES_PRO_GSM*2)) {
	  int fehlbytes = (ANZ_SAMPLES_PRO_GSM*2) - ((recordbuffer->bufsize) % (ANZ_SAMPLES_PRO_GSM*2));
	  recordbuffer->changesize((recordbuffer->bufsize)+fehlbytes);
	  memset((recordbuffer->data)+(recordbuffer->bufsize)-fehlbytes,0,fehlbytes);
	};
      };

      while((recordbuffer->bufsize)>=ANZ_SAMPLES_PRO_GSM*2) {
	SOUND_compressgsm(compressbuffer->data,recordbuffer->data);
	recordbuffer->vornekill(ANZ_SAMPLES_PRO_GSM*2);
	for (liste_elem<outconnection> *i=outconnectionlist->first;i;i=i->next)
	  i->objptr->sendeblock(compressbuffer);
      };

      if (!RECORDER_moechterecord) {
	SOUND_setrecordingmode(0);
	SOUND_setrecordlock(0);
	RECORDER_ichrecorde=0;
	clientconnection::sendmsg(MSG_STATUS_OF_RECORD,
				  &RECORDER_ichrecorde,sizeof(RECORDER_ichrecorde));
	if (recordbuffer->bufsize) fatalfehler("RECORDER_handleevent: recordbuffer muss 0 bytes gross sein");
	for (liste_elem<outconnection> *i=outconnectionlist->first;i;i=i->next)
	  i->objptr->sendeforcemsg();
      };
    };
  };
};


void RECORDER_toggleaufnahme()
{
  RECORDER_moechterecord=!RECORDER_moechterecord;
  clientconnection::sendmsg(MSG_STATUS_OF_RECORDWISH,
			    &RECORDER_moechterecord,sizeof(RECORDER_moechterecord));
  WARTER_reenter=1;
};
